/****
 *
 * Ttulo: Comparando Nmeros Reais
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/06/2012
 * ltima modificao: 12/06/2013
 *
 * Descrio: Mostra como comparar nmeros reais
 *
 * Entrada: No h
 *
 * Sada: Mensagens informando resultados de comparaes de nmeros reais
 *
 ****/

#include <stdio.h> /* Funo printf() */
#include <math.h>  /* Funo fabs()   */

   /* Preciso utilizada na comparao de valores do tipo double */
#define DELTA 1.0E-14

/****
 *
 * ComparaDoubles(): Compara dois valores do tipo double
 *
 * Parmetros:
 *      d1, d2 (entrada): valores que sero comparados
 *
 * Retorno: 0, se os nmeros forem considerados iguais
 *          -1, se d1 for considerado menor do que d2
 *          1, se d1 for considerado maior do que d2
 *
 ****/
int ComparaDoubles(double d1, double d2)
{
   /*                                                  */
   /* Verifica se o valor absoluto da diferena entre  */
   /* os nmeros  menor do que ou igual  preciso    */
   /* determinada pela constante DELTA. Se for o caso, */
   /* eles so considerados iguais. Caso contrrio,    */
   /* verifica qual deles  menor ou maior.            */
   /*                                                  */

   if (fabs(d1 - d2) <= DELTA) {
      return 0; /* d1 e d2 so considerados iguais */
   } else if (d1 < d2) {
      return -1; /* d1  menor do que d2 */
   } else {
      return 1; /* d1  maior do que d2 */
   }
}

/****
 *
 * main(): Testa a funo ComparaDoubles()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   double d = 10.0 - 9.9;

   /*                                                        */
   /* Compara o valor de 'd' com 0.1 usando ComparaDoubles() */
   /*                                                        */

   printf("\n\n>>> Usando ComparaDoubles() <<<\n");

   if (ComparaDoubles(d, 0.1) == 0) {
      printf("\n\t>>> Os valores sao iguais\n");
   } else {
      printf("\n\t>>> Os valores sao diferentes\n");
   }

   return 0;
}

/****************** Resultado do Programa *****************

>>> Usando ComparaDoubles() <<<

        >>> Os valores sao iguais

**********************************************************/
