/****
 *
 * Ttulo: Mdulo para Leitura Resiliente
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2014
 * ltima modificao: 16/04/2014
 *
 * Descrio: Testa funes para leitura de dados robusta
 *
 * Entrada: Strings e opes
 *
 * Sada: Os valores lidos
 *
 ****/

#include <stdio.h>
#include "leitura2.h"

   /* Comprimento mximo do string que ser lido */
#define MAX_STRING 10

/****
 *
 * main(): Testa mdulo para leitura de dados robusta
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   char str[MAX_STRING + 1];
   int  aMais, opcao;

      /* L um string */
   printf( "\nDigite um string com no maximo %d caracteres: ",
           MAX_STRING );
   aMais = LeString(str, MAX_STRING + 1);

   if (*str) {
      printf("\n>>> String lido: %s\n", str);
   } else {
      printf("\n>>> Voce digitou apenas [ENTER]\n");
   }

   if (aMais) {
      printf( "\n>>> Voce digitou %d caracteres a mais\n",
              aMais );
   }

      /* L uma opo */
   printf("\nDigite uma das seguintes opcoes: A, B ou C: ");
   opcao = LeOpcao("ABCabc");

   printf("\n>>> Sua opcao foi: '%c'\n", opcao);

   return 0;
}

/******************* Exemplo de Execuo ******************

Digite um string com no maximo 10 caracteres: Otorrinologista

>>> String lido: Otorrinola

>>> Voce digitou 5 caracteres a mais

Digite uma das seguintes opcoes: A, B ou C: x

        >>> Opcao incorreta. Tente novamente
        > a

>>> Sua opcao foi: 'a'

**********************************************************/
