/****
 *
 * Exemplo: Demonstra o uso de recurso
 *
 * Seo: 4.1
 *
 * Descrio: Calcula recursivamente a soma dos valores de 1
 *            at um certo valor inteiro positivo
 *
 ****/

#include <stdio.h> /* printf() */

/****
 *
 * SomaAteN(): Calcula recursivamente a soma dos valores
 *             compreendidos entre 1 e o valor recebido como parmetro
 *
 * Parmetros:
 *      n (entrada) - valor cuja soma at ele ser calculada
 *
 * Retorno: A soma dos valores compreendidos entre 1 e o parmetro
 *
 * Observaes: Este  um mero exerccio DIDTICO. No imite esta
 *              funo na prtica.
 *
 ****/
int SomaAteN(int n)
{
   if (n <= 1)
      return n; /* Condio de parada */
   else
      return (n + SomaAteN(n - 1)); /* Caso recursivo */
}

/****
 *
 * main(): Testa a funo
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int soma;

   soma = SomaAteN(5);

   printf("\n>> Soma de 1 ate' 5: %d\n", soma);

   return 0;
}

/****************** Resultado do Programa *****************


**********************************************************/
