/****
 *
 * Exemplo: Recurso de Cauda
 *
 * Seo: 4.4
 *
 * Descrio: Inverte um array usando uma funo recursiva
 *            que apresenta recurso de cauda
 *
 ****/

#include <stdio.h> /* printf() */

/****
 *
 * InverteArray(): Inverte um array usando apenas iterao
 *
 * Parmetros:
 *      ar (entrada e sada) - array que ser invertido
 *      inicio (entrada) - primeiro ndice do array
 *      fim (entrada) - ndice final do array
 *
 * Retorno: Nada
 *
 ****/
void InverteArray(int ar[], int inicio, int fim)
{
   int aux;

   while (inicio < fim) {
         /* Troca elementos que se encontram */
         /* nos ndices 'inicio' e 'fim'     */
      aux = ar[inicio];
      ar[inicio] = ar[fim];
      ar[fim] = aux;

      ++inicio;
      --fim;
   }
}

/****
 *
 * InverteArrayRec(): Inverte um array recursivamente
 *
 * Parmetros:
 *      ar (entrada e sada) - array que ser invertido
 *      inicio (entrada) - primeiro ndice do array
 *      fim (entrada) - ndice final do array
 *
 * Retorno: Nada
 *
 ****/
void InverteArrayRec(int ar[], int inicio, int fim)
{
   int aux;

   if (inicio < fim) {
         /* Troca elementos que se com */
         /* ndices 'inicio' e 'fim'   */
      aux = ar[inicio];
      ar[inicio] = ar[fim];
      ar[fim] = aux;

      InverteArrayRec(ar, inicio + 1, fim - 1); /* Endereo e2 */
   }
}

/****
 *
 * main(): Testa a funo InverteArrayRec()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int array[] = {2, 5, 1, 7, 3},
       i, final;

      /* Calcula o ltimo ndice do array */
   final = sizeof(array)/sizeof(array[0]) - 1;

      /* Inverte o array */
   InverteArrayRec(array, 0, final); /* Endereo e1 */

      /* Apresenta o array depois da inverso */
   printf("\n\t>>> Array Invertido <<<\n\n\t> ");
   for (i=0; i <= final; i++) {
      printf("%d   ", array[i]);
   }

   return 0;
}

/****************** Resultado do Programa *****************

        >>> Array Invertido <<<

        > 3   7   1   5   2

**********************************************************/
