/****
 *
 * Ttulo: Calculando Comprimento de String Recursivamente
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2014
 * ltima modificao: 16/04/2014
 *
 * Descrio: Calcula o comprimento de um string
 *            usando uma funo recursiva
 *
 * Entrada: No h
 *
 * Sada: O comprimento de um string constante
 *
 ****/

#include <stdio.h>

/****
 *
 * ComprimentoStrRec(): Calcula o comprimento de um
 *                      string recursivamente
 *
 * Parmetros:
 *      str (entrada) - o string
 *
 * Retorno: O comprimento do string recebido como parmetro
 *
 ****/
int ComprimentoStrRec(const char *str)
{
   if (!*str) /* O string  vazio */
      return 0; /* Caso terminal */

      /* Caso recursivo */
   return 1 + ComprimentoStrRec(str + 1);
}

/****
 *
 * main(): Testa a funo ComprimentoStrRec()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   char *p = "Bola";

   printf( "\nComprimento de %s = %d\n", p,
           ComprimentoStrRec(p) );

   return 0;
}

/****************** Resultado do Programa *****************

Comprimento de Bola = 4

**********************************************************/
