/****
 *
 * Ttulo: Removendo Vogais de um String Recursivamente
  *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2015
 * ltima modificao: 16/04/2015
 *
 * Descrio: Remove vogais de um string usando uma funo recursiva
 *
 * Entrada: No h
 *
 * Sada: Um string antes e depois de ter suas vogais removidas
 *
 ****/

#include <stdio.h>  /* printf() */
#include <string.h> /* strcpy() */

/****
 *
 * RemoveVogais(): Remove recursivamente as vogais de um string
 *
 * Parmetros:
 *      str (entrada e sada) - o string
 *
 * Retorno: Nada
 *
 ****/
void RemoveVogais(char *str)
{
   static const char *const vogais = "aeiouAEIOU";

   if (!*str) /* O string  vazio */
      return; /* Caso terminal */

      /* Casos recursivos */
   if (strchr(vogais, *str)) /* Encontrada uma vogal */
      RemoveVogais(strcpy(str, str + 1));
   else
      RemoveVogais(str + 1);
}

/****
 *
 * main(): Testa a funo RemoveVogais()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   char str[] = "Banana";

   printf("\nString antes: %s\n", str);

   RemoveVogais(str);

   printf("\nString depois: %s\n", str);

   return 0;
}

/****************** Resultado do Programa *****************

String antes: Banana

String depois: Bnn

**********************************************************/
