/****
 *
 * Ttulo: Um Algoritmo com Estimativa O(n^2)
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2014
 * ltima modificao: 16/04/2014
 *
 * Descrio: Apresenta um Algoritmo com Estimativa O(n^2)
 *
 * Entrada: Nenhuma
 *
 * Sada: v Resultado do Programa
 *
 ****/

#include <stdio.h> /* printf() */

void BubbleSort(int ar[], int n)
{
   int i, aux,
       ordenado = 0;

   while (!ordenado) {
         /* Supe que o array est ordenado */
      ordenado = 1;

      for (i = 0; i < n - 1; i++){
         if (ar[i] > ar[i+1]){
            ordenado = 0;

            aux = ar[i];
            ar[i] = ar[i+1];
            ar[i+1] = aux;
         }  /* if */
      }

      --n;
   }
}

void ExibeArray(int ar[], int n)
{
   for (int i = 0; i < n; ++i)
      printf("%d\t", ar[i]);
}

/****
 *
 * main(): Testa a funo BubbleSort()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int ar[] = {-1, -3, 5, 2, 1};

   printf("\n   *** Array Desordenado ***\n\n");
   ExibeArray(ar, sizeof(ar)/sizeof(ar[0]));

   BubbleSort(ar, sizeof(ar)/sizeof(ar[0]));

   printf("\n\n   *** Array Ordenado ***\n\n");
   ExibeArray(ar, sizeof(ar)/sizeof(ar[0]));

   return 0;
}

/****************** Resultado do Programa *****************

   *** Array Desordenado ***

-1      -3      5       2       1

   *** Array Ordenado ***

-3      -1      1       2       5

**********************************************************/
