/****
 *
 * Ttulo: Um Algoritmo com Estimativa O(log n)
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2014
 * ltima modificao: 16/04/2014
 *
 * Descrio: Apresenta um Algoritmo com Estimativa O(log n)
 *
 * Entrada: Nenhuma
 *
 * Sada: v Resultado do Programa
 *
 ****/

#include <stdio.h> /* printf() */

int BuscaBinaria( const int ar[], int n, int valor )
{
   int inf, /* Limite inferior */
       sup, /* Limite superior */
       meio; /* Meio do intervalo */

      /* Limites e inferior superior iniciais */
   inf = 0;
   sup = n - 1;

      /* Efetua a busca binria */
   while (inf <= sup) {
         /* Calcula o meio do intervalo */
      meio = inf + (sup - inf)/2;

         /* Verifica se o valor se acha no meio do intervalo */
      if (ar[meio] == valor)
         return meio; /* Encontrado */

         /* Ajusta o intervalo de busca */
      if (valor < ar[meio])
         sup = meio - 1;
      else
         inf = meio + 1;
   }

      /* Elemento no foi encontrado */
   return -1;
}

void ExibeArray(int ar[], int n)
{
   for (int i = 0; i < n; ++i)
      printf("%d\t", ar[i]);
}

/****
 *
 * main(): Testa a funo BubbleSort()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int ar[] = {-3, -1, 1, 2, 5},
       indice;

   printf("   *** Array Ordenado ***\n\n");
   ExibeArray(ar, sizeof(ar)/sizeof(ar[0]));

   indice = BuscaBinaria(ar, sizeof(ar)/sizeof(ar[0]), 2);

   if (indice < 0) {
      printf("\nO elemento 2 nao foi encontrado\n");
   } else {
      printf( "\n\nO elemento 2 foi encontrado na "
              "posicao %d\n", indice );
   }

   return 0;
}

/****************** Resultado do Programa *****************

   *** Array Ordenado ***

-3      -1      1       2       5

O elemento 2 foi encontrado na posicao 3

**********************************************************/
