/****
 *
 * Ttulo: Exponenciao por Quadratura I
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 26/01/2016
 * ltima modificao: 26/01/2016
 *
 * Descrio: Calcula exponenciao utilizando o mtodo
 *            de quadratura
 *
 * Entrada: No h
 *
 * Sada: O resultado do clculo de uma exponenciao
 *
 ****/

#include <stdio.h> /* printf() */

/****
 *
 * ExponenciacaoQuad(): Calcula o valor de um nmero real
 *                      elevado a um nmero inteiro usando
 *                      exponenciao por quadratura
 *
 * Parmetros:
 *      x (entrada) - a base
 *      n (entrada) - o expoente
 *
 * Retorno: O valor de x elevado a y
 *
 * Observaes:
 *     1. Esta funo no lida com casos excepcionais.
 *        I.e., ela no funciona adequadamente quando
 *        o expoente  negativo ou nulo e a base  0.
 *     2. Esta funo  mais eficiente do que a funo
 *        Exponenciacao1().
 *
 ****/
double ExponenciacaoQuad(double x,int n)
{
   if (n < 0)
      return ExponenciacaoQuad(1/x, -n);

   if (n == 0)
      return 1;

   if (n == 1)
      return x;

   if (n%2 == 0)
      return ExponenciacaoQuad(x*x, n/2);

   return x * ExponenciacaoQuad(x*x, (n-1)/2);
}

/****
 *
 * main(): Testa a funo ExponenciacaoQuad()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   printf( "\n%f elevado a %d = %f\n", -2.0, 3,
           ExponenciacaoQuad(-2.0, 3) );

   return 0;
}

/****************** Resultado do Programa *****************

-2.000000 elevado a 3 = -8.000000

**********************************************************/
