#ifndef _Lista_H_
#define _Lista_H_

/***************** Constantes Simblicas ******************/

#define MAX_ITEM   10 /* Nmero mximo de caracteres num item */
#define MAX_ITENS  20 /* Nmero mximo de itens numa lista */

/****************** Definies de Tipos *******************/

   /* Tipo de cada elemento da lista */
typedef char tItemCompra[MAX_ITEM];

   /* Tipo que representa as listas */
typedef struct {
           int         nItens; /* Nmero de itens na lista */
           tItemCompra itens[MAX_ITENS]; /* Os itens */
        } tListaCompras;

/******************* Aluses de Funes *******************/

extern void IniciaLista(tListaCompras *lista);
extern int Comprimento(const tListaCompras *lista);
extern char *ObtemItem(const tListaCompras *lista, int pos);
extern void InsereItem( tListaCompras *lista, tItemCompra elemento, int pos );
extern char *RemoveItem(tListaCompras *lista, int pos);
extern int EstaVazia(const tListaCompras *lista);
extern int BuscaItem(const tListaCompras *lista, tItemCompra elemento);
extern void AcrescentaItem(tListaCompras *lista, tItemCompra elemento);
extern void AlteraItem(tListaCompras *lista, tItemCompra valor, int pos);
extern int EstaCheia(const tListaCompras *lista);

#endif
