#ifndef _Lista_H_
#define _Lista_H_

/*************************** Constantes Simblicas ***************************/

#define MAX_NOME      20 /* Nmero mximo de caracteres num nome */
#define TAM_MATR      4  /* Nmero de caracteres numa matrcula  */
#define MAX_ELEMENTOS 20 /* Nmero mximo de alunos na lista  */

/**************************** Definies de Tipos ****************************/

typedef char tNome[MAX_NOME + 1];      /* Tipo do nome */
typedef char tMatricula[TAM_MATR + 1]; /* Tipo da matrcula */

typedef struct {
           tNome      nome;   /* Nome do aluno */
           tMatricula matr;   /* Sua matrcula */
           double     n1, n2; /* Suas notas    */
        } tAluno;

typedef struct {
           tAluno alunos[MAX_ELEMENTOS];
           int    nAlunos;
        } tListaAlunos;

/******************* Aluses de Funes *******************/

extern int EstaCheia(const tListaAlunos *lista);
extern void IniciaLista(tListaAlunos *lista);
extern int Comprimento(const tListaAlunos *lista);
extern tAluno ObtemElemento(const tListaAlunos *lista, int indice);
extern int InsereEmOrdem(tListaAlunos *lista, const tAluno *aluno);
extern tAluno RemoveElemento(tListaAlunos *lista, int indice);
extern int EstaVazia(const tListaAlunos *lista);
extern int BuscaBinariaNome(const tListaAlunos *lista, tNome nomeProcurado);
extern int BuscaSequencialMatr(const tListaAlunos *lista, tMatricula matrProcurada);

#endif
