/****
 *
 * Ttulo: Lista Indexada sem Ordenao
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2015
 * ltima modificao: 16/04/2015
 *
 * Descrio: Gerencia uma lista de compras permitindo
 *            desfazer e refazer operaes
 *
 * Entrada: Itens (strings) e opes escolhidas pelo usurio
 *
 * Sada: A lista criada pelo usurio
 *
 ****/

/*********************** Includes *************************/

#include <stdio.h>    /* Funes de Entrada/Sada */
#include <string.h>   /* Processamento de strings */
#include <stdlib.h>   /* Funes de alocao dinmica e */
                      /* gerao de nmeros aleatrios  */
#include <time.h>     /* Funo time() para alimentar o */
                      /* gerador de nmeros aleatrios  */
#include "Lista.h"    /* Interface do tipo lista  */

/***************** Definies de Funes ******************/

/****
 *
 * ExibeDoInicio(): Exibe na tela do primeiro ao ltimo
 *                  elemento de uma lista indexada
 *
 * Parmetros:
 *     *lista (entrada) - a lista
 *
 * Retorno: Nada
 *
 ****/
void ExibeDoInicio(tListaIdx *lista)
{
   int tamanho = Comprimento(lista);

   for (int i = 0; i < tamanho; ++i) {
      printf("%d\t", ObtemElemento(lista, i));
   }
}

/****
 *
 * main(): Testa as operaes sobre listas
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main (void)
{
   tListaIdx lista;
   int    i, valor;

   IniciaLista(&lista);

      /* Ser criada uma lista inicial com 10 elementos. */
      /* Os contedos destes elementos sero nmeros     */
      /* inteiros entre 0 e 100 gerados aleatoriamente   */

      /* Alimenta o gerador de nmeros aleatrios */
   srand((int) time(NULL));

      /* Cria a lista inicial */
   for (i = 1; i <= 10; ++i) {
      valor = (int) rand()%100 + 1;
      AcrescentaElemento(&lista, valor);
   }

      /* Exibe a lista a partir do incio */
   printf("\n\n\t *** Lista a partir do inicio ***\n");
   ExibeDoInicio(&lista);

      /* Faz com que trs elementos contenham o mesmo valor */
   AlteraElemento(&lista, 2, -1);
   AlteraElemento(&lista, 5, -1);
   AlteraElemento(&lista, 7, -1);

      /* Verifica se a operao anterior foi bem sucedida */
   printf( "\n\n>>> Comprimento da lista: %d\n",
           Comprimento(&lista) );

      /* Verifica se a operao anterior foi bem sucedida */
   printf("\n\n\t *** Lista a partir do inicio ***\n");
   ExibeDoInicio(&lista);

      /* Testa a funo RemoveDuplicatas() */
   RemoveDuplicatas(&lista);

      /* Verifica se a operao anterior foi bem sucedida */
   printf( "\n\n>>> Comprimento da lista: %d\n",
           Comprimento(&lista) );
   printf("\n\n\t *** Lista a partir do inicio ***\n");
   ExibeDoInicio(&lista);

   return 0;
}

/******************* Exemplo de Execuo ******************

         *** Lista a partir do inicio ***
34      21      25      57      36      5       8       45      96      7

>>> Comprimento da lista: 10


         *** Lista a partir do inicio ***
34      21      -1      57      36      -1      8       -1      96      7

>>> Comprimento da lista: 8


         *** Lista a partir do inicio ***
34      21      -1      57      36      8       96      7

**********************************************************/
