/****
 *
 * Ttulo: Filas
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/06/2012
 * ltima modificao: 16/06/2012
 *
 * Descrio: Testa as operaes sobre filas.
 *
 * Entrada: No h
 *
 * Sada: Resultados de operaes sobre filas
 *
 ****/

#include <stdio.h> /* Entrada e Sada         */
#include "Fila.h"  /* Definies do tipo fila */

/****
 *
 * main(): Testa as operaes sobre filas.
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main (void)
{
   tFilaIdx fila;
   char  c;

   CriaFilaIdx(&fila);  /* Inicializa a fila */

   c = 'a';
   EnfileiraIdx(&fila, (tItemFila *) &c);  /* EnfileiraIdx 'a' */

   c = 'b';
   EnfileiraIdx(&fila, (tItemFila *) &c);  /* EnfileiraIdx 'b' */

   c = 'c';
   EnfileiraIdx(&fila, (tItemFila *) &c);  /* EnfileiraIdx 'c' */

      /* Imprime o elemento na frente da fila sem remov-lo */
   printf("\nElemento na frente: %c", ElementoFrenteIdx(&fila));

      /* Remove e imprime sucessivamente os elementos na frente da fila */
   printf("\nRetirado: %c", DesenfileiraIdx(&fila));
   printf("\nRetirado: %c", DesenfileiraIdx(&fila));
   printf("\nRetirado: %c", DesenfileiraIdx(&fila));

      /* Agora, a fila est vazia. Se o comentrio da instruo */
      /* a seguir for removida, o progrma ser abortado         */
   /* printf("\nRetirado: %c", DesenfileiraIdx(&fila)); */

      /* O lao a seguir serve para testar a funo FilaIdxCheia(). */
      /* Se o corpo desta funo for substitudo simplesmente por   */
      /* return f->fundo >= MAX_ELEMENTOS - 1, o programa ser      */
      /* abortado devido a uma falsa indicao de fila cheia.       */
   for (c = 'a'; c <= 'z'; ++c) {
      EnfileiraIdx(&fila, (tItemFila *) &c);
      printf("\nRetirado: %c", DesenfileiraIdx(&fila));
   }

   return 0;
}

/************* Resultado da Execuo do Programa *************




**************************************************************/
