/****
 *
 * Ttulo: Filas Circulares
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/06/2012
 * ltima modificao: 16/06/2012
 *
 * Descrio: Testa as operaes sobre filas.
 *
 * Entrada: No h
 *
 * Sada: Resultados de operaes sobre filas
 *
 ****/

#include <stdio.h> /* Funes de Entrada/Sada        */
#include "FilaC.h" /* Cabealho do tipo fila circular */

/****
 *
 * main(): Testa as operaes sobre filas circulares
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main (void)
{
   tFilaC  fila;
   char    c;

   CriaFilaC(&fila);  /* Inicializa a fila */

   c = 'a';
   AcrescentaC(&fila, (tElemento *) &c);  /* AcrescentaC 'a' */

   c = 'b';
   AcrescentaC(&fila, (tElemento *) &c);  /* AcrescentaC 'b' */

   c = 'c';
   AcrescentaC(&fila, (tElemento *) &c);  /* AcrescentaC 'c' */

      /* Imprime o elemento na frente da fila sem remov-lo */
   printf("\nElemento na frente: %c", ElementoFrenteC(&fila));

      /* Remove e imprime sucessivamente os elementos na frente da fila */
   printf("\nRetirado: %c", RetiraC(&fila));
   printf("\nRetirado: %c", RetiraC(&fila));
   printf("\nRetirado: %c", RetiraC(&fila));

      /* Agora, a fila est vazia. Se o comentrio da instruo */
      /* a seguir for removida, o progrma ser abortado         */
   /* printf("\Retirado: %c", RetiraC(&fila)); */

      /* O lao a seguir serve para testar a funo FilaCheiaC().  */
      /* Se o corpo desta funo for substitudo simplesmente por  */
      /* return f->fundo >= MAX_ELEMENTOS - 1, o programa ser     */
      /* abortado devido a uma falsa indicao de fila cheia.      */
   for (c = 'a'; c <= 'z'; ++c) {
      AcrescentaC(&fila, (tElemento *) &c);
      printf("\nRetirado: %c", RetiraC(&fila));
   }

   return 0;
}

/************* Resultado da Execuo do Programa *************




**************************************************************/
