/****
 *
 * Ttulo: Filas
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/06/2012
 * ltima modificao: 16/06/2012
 *
 * Descrio: Testa as operaes sobre filas.
 *
 * Entrada: No h
 *
 * Sada: Resultados de operaes sobre filas
 *
 ****/

#include <stdio.h> /* Entrada e Sada         */
#include "Fila.h"  /* Definies do tipo fila */

/****
 *
 * main(): Testa as operaes sobre filas.
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero, se no ocorrer nenhum erro.
 *          Um valor diferente de zero em caso contrrio.
 *
 ****/
int main (void)
{
   tFilaIdxD fila;
   char  c;

   CriaFilaIdxD(&fila);  /* Inicializa a fila */

   c = 'a';
   EnfileiraIdxD(&fila, (tItemFila *) &c);  /* Acrescenta 'a' */

   c = 'b';
   EnfileiraIdxD(&fila, (tItemFila *) &c);  /* Acrescenta 'b' */

   c = 'c';
   EnfileiraIdxD(&fila, (tItemFila *) &c);  /* Acrescenta 'c' */

      /* Imprime o elemento na frente da fila sem remov-lo */
   printf("\nElemento na frente: %c", ElementoFrenteIdxD(&fila));

      /* Remove e imprime sucessivamente os elementos na frente da fila */
   printf("\nRetirado: %c", DesenfileiraIdxD(&fila));
   printf("\nRetirado: %c", DesenfileiraIdxD(&fila));
   printf("\nRetirado: %c", DesenfileiraIdxD(&fila));

      /* Agora, a fila est vazia. Se o comentrio da instruo */
      /* a seguir for removida, o progrma ser abortado         */
   /* printf("\nRetirado: %c", DesenfileiraIdxD(&fila)); */

      /* O lao a seguir serve para testar a funo EstaCheiaFilaIdxD().  */
      /* Se o corpo desta funo for substitudo simplesmente por */
      /* return f->fundo >= MAX_ELEMENTOS - 1, o programa ser    */
      /* abortado devido a uma falsa indicao de fila cheia.     */
   for (c = 'a'; c <= 'z'; ++c) {
      EnfileiraIdxD(&fila, (tItemFila *) &c);
      printf("\nRetirado: %c", DesenfileiraIdxD(&fila));
   }

   return 0;
}

/************* Resultado da Execuo do Programa *************




**************************************************************/
